leetcode-9-basic-binary search

278. First Bad Version

You are a product manager and currently leading a team to develop a new product. Unfortunately, the latest version of your product fails the quality check. Since each version is developed based on the previous version,

all the versions after a bad version are also bad.

Suppose you have n versions [1, 2, ..., n] and you want to find out the first bad one, which causes all the following ones to be bad.

You are given an API bool isBadVersion(version) which will return whether version is bad. Implement a function to find the first bad version. You should minimize the number of calls to the API

解题思路:

二分查找。需要注意的是,下标是从1开始的。。几次WA都是因为看作0开始了。。我真是大写的蠢。

// Forward declaration of isBadVersion API.
bool isBadVersion(int version);

class Solution {
public:
    int firstBadVersion(int n) {
        int left = 1;
        int right = n;
        int mid = left+(right-left)/2;
        while (left < right) {
            if (isBadVersion(mid) == true) {
                right = mid;
            } else {
                left = mid+1;
            }
            mid = left+(right-left)/2;
        }
        return left;
    }
};

  

原文地址:https://www.cnblogs.com/pxy7896/p/6530026.html